## ----echo=FALSE----------------------------------------------------------------------------
#unha vez que se ten o código listo, e de cara a sacar un documento limpo podense inicializar uns
#parámetros, que me eviten a apariciónde avisos, a non ser que sexan erros 
knitr::opts_chunk$set(warning=FALSE)
knitr::opts_chunk$set(message=FALSE)

#que significa knitr::algo_mais
#eses para de "dous puntos" indica que queremos usar un comando dun paquete que non está subido á memoria
#con library. Só nos interesa puntualmente, polo que só usamos ese comando con referencia ao nome do paquete


## ------------------------------------------------------------------------------------------
library(ggplot2)
library(pastecs)
library(psych)
library(DescTools)
#options(scipen=999)#para que non saia notacion cientifica

## ------------------------------------------------------------------------------------------

datos=read.csv2("exemplo.csv")

set.seed(2021)
D=rbinom(100,5,0.45)
X=rnorm(100,3*D/3,0.5)
Y=4*X+rnorm(100)


## ------------------------------------------------------------------------------------------
summary(datos)
summary(X)


## ------------------------------------------------------------------------------------------
stat.desc(diamonds)#library(pastecs)
describe(diamonds)#library(psych); Ollo!! cos atributos, que os numeriza
Desc(diamonds)#library(DescTools) isto é un monstro
Desc(diamonds$price)


## ------------------------------------------------------------------------------------------
by(X,D,mean)
by(diamonds$price,diamonds$clarity,mean)


## ------------------------------------------------------------------------------------------
# library(DescTools)
Desc(datos$price~datos$clarity)
Desc(price+carat~clarity,data=datos)


## ------------------------------------------------------------------------------------------
# library(psych)
describeBy(datos$price,datos$clarity)#funciona mal en Rmd


## ------------------------------------------------------------------------------------------
plot(datos$carat,datos$price)
#engade o título
title(main = "Relación entre peso e prezo")
plot(datos$carat,datos$price,main = "Relación entre peso e prezo")



## ----echo=FALSE----------------------------------------------------------------------------
filas=8
v.x=rep(1:filas,filas)
v.y=rep(filas:1,each=filas)
v.pch=c(filas^2:33,25:1)

  plot(1, type="n", xlab="", ylab="", xlim=c(0.9, filas+0.1), ylim=c(0.9, filas+0.1),axes = FALSE)
  points(v.x[v.pch],v.y[v.pch] ,pch=v.pch,col=2)
    text(v.x[v.pch],v.y[v.pch] ,paste(v.pch,": ",sep=""),cex=0.7,pos = 2,col=12)
   


## ----echo=FALSE,fig.width=6----------------------------------------------------------------
filas=7
v.x=rep(1,5)
v.y=filas:1-1

  plot(1, type="n", xlab="", ylab="", xlim=c(0.9, 4), ylim=c(0, filas+0.1),axes = FALSE)
 # points(v.x[v.pch],v.y[v.pch] ,pch=v.pch,col=2)
    text(v.x,v.y ,paste(0:6,". ",sep=""),cex=0.7,pos = 2,col=12)

    text(v.x+.6,v.y ,paste(c("blank","solid","dashed","dotted","dotdash","longdash","twodash")
                           ,sep=""),pos = 2,col=12)

for ( i in 6:0){
  lines(c(1.8,2),c(6-i,6-i),lty=i,col=2)
}
   


## ----eval=FALSE----------------------------------------------------------------------------
## #Este primeiro comando abre un 'device' png, ou sexa, o dispositivo que manexa os gráficos
## #vai escribilos directamente nun ficheiro dese tipo.
## #ademais faino cun fondo transparente (bg="transparent")
## #ancho de 1024 pixels e altura de 768
png(file = "myplot.png", bg = "transparent", width = 1024, height = 768)
barplot(c(3,1,1,4)) #realiza o gráfico, coma sempre
dev.off() #pecha o "device", agora os gráficos apareceran onda sempre


## ----eval=FALSE----------------------------------------------------------------------------
png(file = "myplot%d.png")
barplot(c(3,1,1,4)) #realiza o gráfico myplot1.png
hist(rnorm(100))#realiza o gráfico myplot2.png
plot(rnorm(20),runif(20))#realiza o gráfico myplot3.png
dev.off() #pecha o "device", agora os gráficos apareceran onda sempre


## ------------------------------------------------------------------------------------------
###########ggplot2
#comézase cargando o paquete na memoria:
library(ggplot2)
datos=read.csv2("exemplo.csv")


## ------------------------------------------------------------------------------------------
ggplot(datos) #con isto non fai nada, posto que non se lle dixo que se quere facer


## ------------------------------------------------------------------------------------------
ggplot(datos,aes(x=carat,y=price))


## ------------------------------------------------------------------------------------------
ggplot(datos,aes(x=carat,y=price))+geom_point()#geom_point é a capa para un diagrama de dispersion


## ------------------------------------------------------------------------------------------
#facetas: permite facer os graficos separados polos niveis de 1 ou mais atributos
ggplot(datos,aes(x=carat,y=price))+geom_point()+facet_grid(~clarity)


## ------------------------------------------------------------------------------------------
#temas: permiten variar o aspecto dos gráficos,usando motivos predefinidos.
#tedes exemplos na chuleta.6.ggplot2.r
ggplot(datos,aes(x=carat,y=price))+geom_point()+facet_grid(~clarity)+theme_bw()

ggplot(datos,aes(x=carat,y=price))+geom_point()+facet_grid(~clarity)+theme_dark()


## ------------------------------------------------------------------------------------------
# ¢omparación co plot básico
plot(datos$carat,datos$price)


## ------------------------------------------------------------------------------------------
#densidade
#necesita so unha variable, continua.
ggplot(datos,aes(x=carat)) + 
  geom_density(fill="aquamarine", color="salmon")+
  theme_minimal()

ggplot(datos,aes(x=price)) + 
  geom_density(fill="blue", color="gray")+
  theme_minimal()


## ------------------------------------------------------------------------------------------
#HISTOGRAMA
# breaks=seq(20, 50, by = 2) metido no geom_histogram indica os extremos dos intervalos 
#seq(20, 50, by = 2) crea unha sucesion comezando en 20, rematando en 50 e saltando de 2 en 2
seq(20, 50, by = 2)
#se a liña remata en + continua na liña seguinte:
ggplot(datos, aes(carat)) + 
  geom_histogram(breaks=seq(0, 1.2, by = 0.2), 
                 col="red", 
                 fill="green", 
                 alpha = .2) + 
  labs(title="Histogram for Carat") +
  labs(x="Carat", y="Count") + 
  xlim(c(0,1.2)) + 
  ylim(c(0,30))

#xlim() e ylim() indican entre que valores se debuxan os eixes x e y


## ------------------------------------------------------------------------------------------
## Diagrama de dispersión con recta de regresión e regresión suavizada:
#as graficas creadas en ggplt2 poden ser gardadas como un obxecto e non se ve a súa representación.
#na seguinte liña gardase a grafica realizada e chámaselle p:
p=ggplot(data=datos,aes(x = carat, y = price))+  
  geom_point(aes(colour=clarity),shape = 5, fill = "white", size = 1.4)

#Agora pode verse executando p:
p
#e pódenselle engadir cousas a ver como queda, por exemplo unha regresión liñal
p+   geom_smooth(method=lm,  se=FALSE)
#ou unha curva de regresión non parámetrica
p+   geom_smooth(method=loess, se=FALSE)
#cun intervalo de confianza para os valores
p+   geom_smooth(method=loess)


